CF_NATIVE       equ 1   ; CFꍇL
;----------------------------------------------------------------------------
; PC-9821(486) IDE BIOS patch Version 3.00 (C) 2001-06,2018-21,24 ܂
;----------------------------------------------------------------------------
MEMseg          equ     5C00h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗v)  
SND_equip       equ     80h     ; SND BIOS bit(A-mate,FELLOW)
; p[^[h̒萔l(l)
MODE_M9         equ  0
MODE_MIXED_SCSI equ  1
MODE_ORTHO_SCSI equ  2
MODE_MEL_SCSI   equ  3
MODE_SSD_SCSI   equ  4
MODE_MIXED_SSD  equ  5
MODE_4G_COMPATI equ  6

MSG_DISP_LINE   equ     14      ; \JnsłBKXĂB
; Global stack variables -----------------
ROW             equ     word ptr [bp-4] ; \s
COLUMN          equ     word ptr [bp-6] ; \J
SegTVRAM        equ     word ptr [bp-8] ; T-VRAM̃ZOgA000/E000
HiresoFlag      equ     byte ptr [bp-10] ; 01h Hi-reso flag (bit 0)
equip           equ     byte ptr [bp-12] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
ModeID          equ     byte ptr [bp-13] ; ݂̃p[^[h
MemWindowAddr   equ     byte ptr [bp-14] ; 08-BANK window address in EXROM
COLOR_ATTRIB    equ     byte ptr [bp-15] ; \F
MemWindowNative equ     byte ptr [bp-16] ; 08-BANK window native address
mem_bank_IOaddr equ     word ptr [bp-18] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-20] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-22] ; IDE BIOSZOgiRAMmappingj
MachineID       equ     byte ptr [bp-24] ; Machine ID
MachineType     equ     byte ptr [bp-26] ; [1]=Ap3/BA3, [2]=Xe/Xs/Xp, [4]=An, [5]=Cx/Cb, [0]=Others
SegPhysIDEwork  equ     word ptr [bp-28] ; IDE work areaZOgiIj
NEW_ENTRY       equ     word ptr [bp-30] ; 

;include  e:\asmlib\Instr486.INC
code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                org 103h        ; ""
DefaultModeEx   DB      01h   ; ftHg̃p[^[hliOlj;Ή
title_msg       DB      0E1h,"IDE HDDeʏgCHSp[^ύX  V3.00  @픻",0
machine_typeAn  DB      0E1h,"mAn3n",0
machine_typeA3  DB      0E1h,"mAp3/As3n",0
machine_typeB3  DB      0E1h,"mBX3/BX3n",0
machine_typeX   DB      0E1h,"mX-maten",0
machine_typeC   DB      0E1h,"mCb,Cxn",0
machine_typeUN  DB      0E5h," s ",0
;----------------------------------------------------------------------------
absent_msg      DB      041h,"IDE BIOSoĂ܂ifBXNڑj"
CRLF_msg        DB      20h,13,10,0
;IDE_msg        DB      0E1h,"IDE BIOS݂܂. ",0 ; TCYk̂ߔp~
msg_set         DB     0E1h,"ؽŐݒ",0
msg_param_is    DB     0E1h,"ҰӰ [",0
msg_default     DB     0E1h,"̫ ",0
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_Sector256B  DB      41h," ZN^256B̐ݒł. ",0
msg_AvoidPatch  DB     0E1h," pb`𒆎~܂.",13,10,0
msg_CF4351_nat  DB     0A1h,"Ȳè Ұ ",0
msg_CF4351_HD   DB     0E1h,"HD݊Ұ ",0
msg_CF4351_is   DB     0E1h,"4.3GBCF ",0
msg_dsw         DB     0E1h,"(o̓foCXuިڑƯĎgpvł̐ݒ)",13,10,0
msg_msw         DB     0E1h,"iؽ 2-2 TRM/BAS modeɂݒj",13,10,0
msg_CRLF        DB     0E1h," ",13,10,0

.186
program_start:
                enter   40,0
                mov     COLOR_ATTRIB,0E1h
;;;             mov     OffsetXcode, offset Excode
                mov     al,DefaultModeEx ; ftHg[hlQ
                or      al,al
                jz      @f              ; `l[łȂ!=0ꍇ
                dec     al              ; lɕϊ(-1)
         @@:    mov     ModeID,al       ; Jg[hɑ

                cld
                call    ChkCPU
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
; XCb`̐ݒ݂
                mov     al,es:[3FF6h]   ; XCb`U̎w
                and     al,00000111b    ; }XN
                or      al,al           ; XCb`ÔƂftHg
                jz      NotUsedMEMSW    ; XCb`̒l͊Ol
                dec     al              ; lɕϊ(-1)
                mov     ModeID,al       ; XCb`gpȂ炻ɏ]
NotUsedMEMSW:   
                mov     al,0
                mov     equip,al        ; bit̏l
.386
                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂 2018-12-11V
                call    ModelCheck      ; @풲AcallԒnoffset擾
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~
                call    NOPCI_Check     ; PCI BIOS邩HCY
                jc      WrongMachine    ; CYĂ΋@ႢŃG[
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~
                call    Sector256Byte   ; BIOSZN^𒲍
                jc      AvoidPatch      ; CY=G[ŏI
                call    Scan_GRPH_FK   ; 2024-3-25 ǉidlύXj 
                call    DisplayParamMode    ; p[^[h̕\

                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB
                call    Capa_Patch
                call    AP3_BX3_patch   ; Ap3BX3A486X-matẽpb`
                jc      WrongBIOS
                mov     byte ptr wrong_bios,041h
                call    AdvPIO_patch
                jc      WrongBIOS
                call    SetParamTable   ; MEM,p[^e[uXV
                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
ExitProgram:  
                call    ClearMEMseg     ; ƃNAđދ
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts           ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
WrongBIOS:      mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
;----------------------------------------------------------------
;       PeriEnvCheck ( equiped peripherals ) Ap3,As3,BA3,BX3 only
;----------------------------------------------------------------
PeriEnvCheck    PROC    near
; port F0h      1= HDD/IF Ȃ ,  0=HDD/IF  _
; bit 6: ^Cv(SCSI)HDDXe[^X            40h 
; bit 5: ^Cv(SASI,IDE)HDDXe[^X        20h
                in      al,0F0h
                test    al,20h          ; Internal SASI/IDE exist?
;                jnz     noequip_ide    ; ̃vOłIDE BIOS
;                jnz     IDE_absent      ; ȂƂ̂̓G[ƂȂ
                OR      equip,IDE_equip
noequip_ide:    test    al,40h          ; SCSI(A-mate)݂͑邩?
                jnz     noequip_E10_FA02        ; 2019-1-21
                cmp     MachineType,2   ; Xe,Xs,XpI/O F0 flag bit6̈Ӗ
                je      noequip_E10_FA02   ; Ⴄ悤Ȃ̂Œ!!
                OR      equip,E10_equip
noequip_E10_FA02:
                test    HiresoFlag,1    ; nC]Ȃ疳
                jnz     noequip_sndbios ; SOUND BIOS݂͑ȂƂ
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      noequip_sndbios ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip 
noequip_sndbios:        ; SASI BIOSׂ͒ȂƂɂ
                clc
                ret
IDE_absent:     stc
                ret
PeriEnvCheck    ENDP

;--------------------------------------------------------------+----------+
;       Scan_GRPH_FK  [FE1]`[FE7]L[Ń[hIEL   | 2024/3/29|
; L[Ԃ݂    keycode   e[h̊OlɑΉ |          |
;--------------------------------------------------------------+----------+
Scan_GRPH_FK   PROC   near
                mov     cx,4000
        @@:     mov     ah,2
                int 18h
                test    al,00001000b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     EnterValue
               loop     @b
                jmp     ScanFKEY_abort
EnterValue:     
                mov     dx,offset EnterModeValue
                call    _puts
                call    Poop            ; ````
                xor     ax,ax   ; wait while keybord input 
                int 18h         ; return: AL=key DATA, AH=key CODE
                xchg    al,ah   ; with key CODE
                cmp     al,62h  ; key Code 62h=[F.1] 
                jb      ScanFKEY_abort  ;  `   `
                cmp     al,68h  ; key Code 68h=[F.7]
                ja      ScanFKEY_abort
                sub     al,61h          ; -61hOlƂȂ
                mov     ah,al           ; AH=Ol
                dec     al              ; AL=lɕϊ(-1)
                and     al,00000111b    ; Mask for safety
                mov     ModeID,al       ; [hlm肷
                
                push    ax
                call    Poop            ; ````
                mov     al,0Dh          ; XCb`\ɂ
                out 68h,al
                pop     ax
                mov     COLUMN,0        ; JOɂ
                mov     bx,3FF6h        ; XCb`U
                mov     al,es:[bx]      ; XCb`Uǂݍ
                and     al,11111000b    ; ̃rbgۑ̃}XN
                or      al,ah           ; AH=[hlOl
                mov     es:[bx],al      ; XCb`Uɏ
                mov     al,0Ch          ; XCb`֎~ɂ
                out 68h,al
ScanFKEY_abort:
                ret
EnterModeValue  DB      0C3h,"CHSҰ Ӱނ ==> [F1]`[F7]",0
Scan_GRPH_FK   ENDP

;--------------------------------------------------------
;       machines
;--------------------------------------------------------
include capa_pat.inc
include ap3_pat.inc

;--------------------------------------------------------
;       MEMtoIDEBIOS    5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS    PROC   near
                mov      al,equip ; Internal IDE,SCSI,SND BIOS enable
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                call    ROMRAM486_IDE   ; ݒALbVtbV
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret     ; G[Ԓl͂Ȃ̂Ƃ
MEMtoIDEBIOS    ENDP

;--------------------------------------------------------
;       SetParamTable  Copy ROM board to MEM Ԓl CY
;--------------------------------------------------------
SetParamTable   PROC   near
                mov     ax,MEMseg
                mov     es,ax
;   MEMɃRs[ĂIDE BIOSR[h̒ "ParamTBL"T
                mov     cx,1F00h-30h    ; 
                mov     bx,0030h        ; ͈ offSet 0030hȍ~
EntSearchTBL:   mov     eax,es:[bx]
                mov     edx,es:[bx+4]
                cmp     eax,'araP'      ; Sp^[P
                jne     @f
                cmp     edx,'LBTm'      ; Sp^[Q
                jne     @f
                jE      FoundTBL        ; v
        @@:     inc     bx
               loop    EntSearchTBL
                mov     al,06   ; ParamTBLVOl`Ȃꍇ
                out 37h,al      ; ivbeep
                stc             ; sCYĂ
                ret
FoundTBL:       mov     di,bx   ; ParamTBLVOl`
                add     di,8    ; ̃AhX̂WoCgɃe[u
                movzx   ax,ModeID       ; AX=p[^[h̒l
                mov     si,offset ParamTable1
                shl     ax,4    ; ~16
                add     si,ax   ; [hɑΉe[uoffsetsiɓ
                mov     cx,16/2 ; 16oCgRs[ăe[uu
           rep  movsw

                mov     dx,offset msg_CF4351_is
                call    _puts
                mov     cx,offset msg_CRLF

                push    dx
                mov     dx,8F1Eh        ; mod. 2024-3-24
                in      al,dx
                pop     dx
                test    al,01000000b    ; fBXNڑjbggp=1,gpȂ=0
                mov     cx,offset msg_dsw
                jnz     CF_NativeMode

                in      al,31h  ; DIP SW2-2 
                test    al,00000010b    ; 1=BASIC[h  0=^[~i[h
                mov     cx,offset msg_msw
                jz      CF_NativeMode
                mov     dx,offset msg_CF4351_HD
                call    _puts
                mov     ah,0
                jmp     CF_InitMode
CF_NativeMode:  
                mov     dx,offset msg_CF4351_nat
                call    _puts
                mov     dx,cx
                call    _puts
                mov     ah,1
CF_InitMode:
                mov     al,ModeID       ; AX=p[^[h̒l
                stosw   ; FixedModeID
                clc     ; K
                ret
SetParamTable   ENDP

;--------------------------------------------------------
;       MEMtoROM        5000:0-->ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
MEMtoROM        PROC    near
                mov     es,SegMMapIDEBIOS
                cld
                mov     cx,2000h/2      ; 8KB
                push    cx
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                push    si
                mov     ax,MEMseg
                push    ds
                mov     ds,ax   ; ds=MEMseg, es=IDE BIOSRAMwindow
           rep  movsw
                pop     ds
                pop     si
                pop     cx
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                mov     dx,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
                cld
                mov     cx,2000h/2      ; 8KB
                sub     si,si
                sub     di,di
                mov     ax,MEMseg
                push    ds
                mov     ds,dx   ; DS=DX=^IDE BIOSZOg
                mov     es,ax   ; ES=AX=MEMseg
          rep   movsw
                pop     ds
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE  (ex)     A-mate
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
RAMROM486_IDE   ENDP

;------------------------------------------------------------
;       ResoModeCheck   ŏɂP񂾂Ăяo`FbN
;------------------------------------------------------------
ResoModeCheck   PROC    near
                mov     MemWindowAddr,0Ch
                mov     MemWindowNative,08h
                mov     mem_bank_IOaddr,0461h
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]           ; hi-reso check
                and     al,8    ; 1000b           1      0
                shr     al,2    ;   10b                  0
                add     MemWindowAddr,al        ; 0Eh    0Ch
                shr     al,1    ;    1b
                mov     HiresoFlag,al            ; high/low mode flag
                mov     dx,0A000h       ; Text VRAMZOg
                mov     bx,0F8E8h       ; Machine ID i[ZOg(BIOS)
                mov     ah,00h          ; AH bit 7MAchine ID̈ꕔɎg
                or      al,al
                jz      NormalResoMode  
; HIRESOLUTION MODE SETTINGS
                mov     mem_bank_IOaddr,0091h ; Hireso mem-window port
                mov     MemWindowNative,10h;  Hireso mem-window native addr
                mov     dx,0E000h       ; The segment of Text VRAM at H mode
                mov     bx,0FFE8h       ; The segment of Machine ID flag at H.
                mov     ah,80h          ; bit7=1 , Machine IDmnC]rbg
NormalResoMode: mov     es,dx           
                mov     SegTVRAM,dx     ; TEXT VRAMZOgLϐɊi[
                push    ds
                mov     ds,bx
                mov     al,ds:[003Fh]
                pop     ds
                or      al,ah           ; nC]bitƍ
                mov     MachineID,al
                ret
ResoModeCheck   ENDP

;------------------------------------------------------------
;       ModelCheck      BA3,BX3, Xe,Xs,Xp,Xn, Ap3,As3, An
;------------------------------------------------------------
ModelCheck      PROC   near
                mov     al,MachineID
                cmp     al,12h  ; Xe/Xs/Xp?
                je      Machine_XMATE
                cmp     al,84h  ; Ap3/As3 H
                je      Machine_A3
                cmp     al,18h  ; Ap3/As3 N
                je      Machine_A3
                cmp     al,83h  ; An H
                je      Machine_An
                cmp     al,0Dh  ; An N
                je      Machine_An
                cmp     al,16h  ; BX3
                je      Machine_B3
                cmp     al,15h  ; Cx,Cb
                je      Machine_C1
                mov     MachineType,0
                mov     ax,1C00h
ResoModeCheckE: 
                mov     NEW_ENTRY,ax
                mov     bx,offset TABLE_OFFSET_IN_BIOS
                add     [bx],ax
                mov     bx,offset CALL_OFFSET1
                add     [bx],ax
                mov     bx,offset CALL_OFFSET2
                add     [bx],ax
                mov     bx,offset CALL_OFFSET3
                add     [bx],ax
                mov     bx,offset CALL_OFFSET4
                add     [bx],ax
                mov     bx,offset CALL_OFFSET5  ; B*3,X*
                add     [bx],ax
                clc
                ret
Machine_C1:     mov     MachineType,5
                mov     ax,1C00h
                jmp     ResoModeCheckE
Machine_B3:     mov     MachineType,1
                mov     ax,1C00h
                jmp     ResoModeCheckE
Machine_XMATE:  mov     MachineType,2
                call    CheckXM         ; X-matẽj[^Cv΍ 2024/3/24
                jmp     ResoModeCheckE
Machine_A3:     mov     MachineType,3
                mov     ax,1C00h
                jmp     ResoModeCheckE
Machine_An:     mov     MachineType,4
                mov     ax,1C00h
                jmp     ResoModeCheckE
ModelCheck      ENDP

CheckXM         PROC   near     ; X-mateIDE BIOSǉŊȒPɒ 2024/3/24
                push    es
                mov     es,SegPhysIDEBIOS
                mov     eax,es:[1FDCh]
                cmp     eax,0E292C582h
                mov     ax,1DA0h
                jne     @f
                mov     ax,1C10h
        @@:     pop     es
                ret
CheckXM         ENDP

;------------------------------
include numeric.inc     ; l\[`
.386
include advpio.inc
include putstrj3.s      ; \[`
.386
include ideptcom.inc
;------------------------------
;                DD      0EEEEEEEEh      ; I[}[J[

;I/O  00F0h   }VXe[^Xǂݏo^CPUVbg_E
;bit 7: CPUx聡[PC-9821ApAsAeAf]  1=High or Low, 0=Middle
;bit 6: ^Cv(SCSI)HDDXe[^X 1= 55^CvHDDȂ
;bit 5: ^Cv(IDE)HDDXe[^X 1= IDE HDDȂ
;bit 3: RAMANZX 1= W܂͊gXbg
;I/O  841Fh   DIP SWITCHǂݏo
;bit 1: SOUND BIOS   1=use SOUND BIOS  ,  0=release SOUND BIOS
;I/O  8F1Eh   DIP SWITCHǂݏo
;bit 0: 15-16MBԃVXegpL  0=system use  1=RAM use
;align 16

ProgramSize     equ     ( offset CodeEnd - offset Excode )

;======== ȍ~BIOS̗]ɃRs[RAM BIOSɏ풓 ========
;  patch code(IDE BIOS)    ̓X^bNϐ[bp-xx]gp֎~
;  ES=D800h(N-mode)/E600h(H)/E800h(H),  DS=0000h, CS=D800h
cs_FixedModeID  equ      cs:[di]
cs_CF_ModeID    equ      cs:[di+1]
; [si+10h] = [di]̓p[^̒lilj̔Ԓn
;------------------------------------------------------------
Excode          label   byte
NEW_CODE_1C10    label   byte   ; AP3_PAT.INC ŎQƂ
                push    bx
                push    si
                push    di              
                                        ; LBAlIDE work area烊[h
                mov     dx,es:[237Ah]   ; LBAʃ[hwork areao
                xchg    dl,dh           ; gGfBA
                mov     ax,es:[2378h]   ; LBAʃ[h
                xchg    al,ah           ; gGfBA
                ror     eax,16          
                mov     ax,dx           
                rol     eax,16          ; EAX̏16 DXƓ
IF 0 ; ȉTCY̓sŖɂ̂ŁALBÂȂHDD̎gp͕s\
                or      eax,eax         ; 0 ̂Ƃ
                jnz     LBA_Supported
NonLBA:         
                mov     ax,es:[230Ch]  ; sectN
                xchg    al,ah
                mov     cx,es:[2306h]  ; headN
                xchg    cl,ch
                mul     cl
                mov     cx,es:[2302h]  ; cylnN
                xchg    cl,ch
                mul     cx
                ror     eax,16
                mov     ax,dx
                rol     eax,16
LBA_Supported:
ENDIF

;;              mov     si,offset ExParamTable 
                DB      0BEh
TABLE_OFFSET_IN_BIOS    label word
                DW      ( offset ExParamTable  - offset Excode )
                mov     di,si
                add     di,10h

ifdef CF_NATIVE         ;2020-12-7  CFǂ
                call    CheckCF
                jc      ParamIsCHS_CFA
endif

                cmp     eax,00880000h   ; 4351.9MBȂ
                jb      ParamSet        ; e[uʂɃZbg
                inc     si      
                inc     si              ; 

                mov     cx,cs:[si]      ; 4351---8192MB
                cmp     byte ptr cs_FixedModeID, MODE_M9                ;(0)
                jz      Head_Sect63Mode 
                cmp     byte ptr cs_FixedModeID, MODE_4G_COMPATI        ;(6)
                jz      Head_Sect63Mode 

;                cmp     eax,01000000h   ; 8192MB Ȃ
                cmp     dx,0100h   ; 8192MB Ȃ
                jb      ParamSet         ; CXʂɃZbg
                inc     si
                inc     si
;;              cmp     eax,03EFFC10h   ; 2018/7/31.5GB Ȃ
;;              jb      ParamSet         ; CXʂɃZbg
                inc     si
                inc     si
Over65535Cyl:
;                cmp     eax,04000000h ; 32GB
                cmp     dx,0400h ; 32GB
                jb      ParamSet
                cmp     byte ptr cs_FixedModeID, MODE_ORTHO_SCSI ;(2)
                je      ortho_scsi_mode ; ̃[hł͂őł~
                inc     si
                inc     si
;                cmp     eax,07800000h ; 61440MB
                cmp     dx,0780h ; 61440MB
                jb      ParamSet
; 61.44GBȏ
                inc     si
                inc     si
;                cmp     eax,08000000h; 65536MB
                cmp     dx,0800h; 65536MB
                jb      ParamSet
; 64GBȏ
                cmp     byte ptr cs_FixedModeID, MODE_SSD_SCSI ;(=4)
                je      ssd_scsi_mode   ; ̃[hł͂őł~
                inc     si
                inc     si
; 120GBȏ
;                cmp     eax,0EF10000h; 122.4GB
                cmp     dx,0EF1h; 122.4GB
                jb      ParamSet

                cmp     byte ptr cs_FixedModeID, MODE_MEL_SCSI ; (=3)
                je      ext_scsi_mode   ; ̃[hł͂őł~
;;;;                inc     si
;;;;                inc     si
; 16*255*65535 limit
                mov     cx,10FFh
                mov     dx, 0FEFh
                mov     ax,0F010h-1
                jmp     ParamOK
ParamSet:       
                mov     cx,cs:[si]
ParamOK:
                and     eax,0000FFFFh   ; 16bit̂Ă
                call    SetDevNum
                mov     es:[bx+07h],cl        ; Sector count
                mov     es:[bx+0Ah],ch        ; Head count
                mov     es:[bx+0Eh],cx        ; Head and Sect count
                mov     es:[bx+02h],ax        ; LBA-L
                mov     es:[bx+04h],dx        ; LBA-H
                push    ax
                mov     ah,00h
                mov     al,ch
                mul     cl
                mov     es:[bx+08h],ax        ; H*S
                mov     cx,ax
                pop     ax
                div     cx
                mov     es:[bx],ax        ; cylinder count
                pop     di
                pop     si
                pop     bx
                RET
align 2       ; "ParamTBL"
                DB      "Para" 
                DB      "mTBL"
ExParamTable    DW      0811h   ; `4351MB ; 0
                DW      0820h   ; `8.00GB ; 2 ; UIDE compatible = 103Fh *
                DW      0880h   ; `31.5GB ; 4 ; UIDE compatible = 103Fh *
                DW      0880h   ; `32.0GB ; 6 ; M9   compatible = 10FFh
                DW      0F80h   ; `61.4GB ; 8 ;
                DW      1080h   ; `64.0GB ; A ; 2018-12-12ǉ
                DW      10FFh   ; `122 GB ; C ;
                DW      10FFh   ; `127 GB ; E ;
FixedModeID     DB      00h     ; Copied ModeID   ROMłcs_FixedModeID
CF_FlagFixed    DB      00h     ; Copied from SOFTWARE SWITCH

ortho_scsi_mode:
                mov     dx,03FFh    ; Overflow΍, LBAlimit
                mov     ax,0FFFFh   ;   LBA max=0400000h
                jmp     ParamSet
ext_scsi_mode:  
                mov     dx, 0EF0h
                mov     ax,0FFFFh
                jmp     ParamSet
ssd_scsi_mode:  
                mov     dx, 07FFh
                mov     ax,0FFFFh
                jmp     ParamSet

Head_Sect63Mode:   ; mode ==0,6
                mov     ch,es:[2306h+1] ; NATIVE foCX HEAD
;;              mov     cl,es:[230Ch+1] ; NATIVE foCX SECTOR
                inc     si      ; `8GB
                inc     si
                inc     si      ; `31.5GB
                inc     si
                cmp     ch,16
                je      Head16
                cmp     ch,15
                je      Head15
                mov al,06       ; Unexpected ERROR
                out 37h,al
Head16:         
                cmp     eax,03EFFC10h; 31.5GB
                jb      ParamOK
                cmp     byte ptr cs_FixedModeID, MODE_4G_COMPATI
                jne     Over65535Cyl
                mov     dx, 00FBh
                mov     ax,0FC10h       ; 8063MB
                jmp     ParamOK
Head15:
                cmp     eax,03B0FC4Fh; 30.7GB
                jb      ParamOK
                cmp     byte ptr cs_FixedModeID, MODE_4G_COMPATI
                jne     Over65535Cyl
                mov     dx, 00ECh
                mov     ax,03C4Fh
                jmp     ParamOK
;-------------------------------------------------------------
ParamIsCHS_CFA: mov     ch,es:[2306h+1] ; NATIVE foCX HEAD
                mov     cl,es:[230Ch+1] ; NATIVE foCX SECTOR
;;                mov     cx,103Fh  ; i16:63̌ߑł͂悭Ȃj
                jmp     ParamOK
;-------------------------------------------------------------
ifdef CF_NATIVE
CheckCF         PROC   near
                test    byte ptr es:[23ACh+1],00000100b  ; CFA bit2 =1 Ȃ犮SCF
                jz      ModeCF_HD       ;       0= not CFA
                test    byte ptr es:[2300h+1],80h ; [h 00̓Ybit removable? 
                jz      ModeCF_HD       ; removableĂȂ̂HDD
                test    byte ptr cs_CF_ModeID,1
                jz      ModeCF_HD
                cmp     eax,00880000h
                jae     ModeCF_HD
                stc     ; 4351MB  and ^[~i[h
                ret
ModeCF_HD:      clc     ; 4351MB over  or BASIC[h
                ret
CheckCF         ENDP

endif
;-------------------------------------------------------------
SetDevNum       PROC    near    ; hCuԍ
                mov     bl,[bp+00]      ; drive#
                and     bx,0003h        ; mask 11b (0..3)
                shl     bx,5            ; *32
                add     bx,2100h        ; base D800:2100h
                ret
SetDevNum       ENDP
;-------------------------------------------------------------
NewFunc_HS_AX   PROC    near
                call    SetDevNum
                mov     al,es:[bx+07h]  ; sect count
                mov     ah,es:[bx+0Ah]  ; head count
                xor     bx,bx
                ret
NewFunc_HS_AX   ENDP
;-------------------------------------------------------------
NewFunc2_HS_AX  PROC    near
                push    cs
                pop     es
                call    NewFunc_HS_AX
                mov     dl,ah
                mov     dh,00h
                mov     cl,al
                mov     ch,00h
                ret
NewFunc2_HS_AX  ENDP
DW      0       ; ȏTCY𑝂₷Ƃ͂łȂ̂codeǉ֎~
;-------------------------------------------------------------
CodeEnd         label byte

code    ends
        end     start
