An_patch        PROC    near

; Func_A  
                mov     si,offset CodePtn_A
                mov     cx,offset CodePtn_A_end
                call    scan_pattern
                jc      BIOS_not_An
                mov     di,bx
                mov     si,offset PatPtn_A
           rep  movsb

; Func_F84     (addr=0448h)
                mov     si,offset CodePtnF84
                mov     cx,offset CodePtnF84_end
                call    scan_pattern
                jc      BIOS_not_An
                mov     di,bx
                mov     si,offset PatPtnF84
           rep  movsb

; Func_C
                mov     si,offset CodePtnC
                mov     cx,offset CodePtnC_end
                call    scan_pattern
                jc      BIOS_not_An
                mov     di,bx
                mov     si,offset PatPtnC
           rep  movsb

; Func_D
                mov     si,offset CodePtnD
                mov     cx,offset CodePtnD_end
                call    scan_pattern
                jc      BIOS_not_An
                mov     di,bx
                mov     si,offset PatPtnD
           rep  movsb
; Func_E
                mov     si,offset CodePtnE
                mov     cx,offset CodePtnE_end
                call    scan_pattern
                jc      BIOS_not_An
                mov     di,bx
                mov     si,offset PatPtn_HS_AX
           rep  movsb

; Func_An
                mov     si,offset CodePtn_An
                mov     cx,offset CodePtn_An_end
                call    scan_pattern
                jc      BIOS_not_An
                mov     di,bx
                mov     si,offset PatPtn_An
           rep  movsb

                mov     di, NEW_ENTRY                            ; patch entry
                mov     cx,(offset CodeEnd - offset ExCode)
                mov     si,offset ExCode
        @@:     mov     al,cs:[si]
                inc     si
                stosb
               loop     @b
               
;FastIDE  2019-7-27
                mov     di, 0012h
                mov     al,0E9h
                stosb
                mov     al,08Bh
                stosb
                mov     al,01Dh
                stosb
                
                mov     di, 1DA0h ; ( An )
                mov     cx,(offset FastIDE_end - offset FastIDE)
                mov     si,offset FastIDE
        @@:     mov     al,cs:[si]
                inc     si
                stosb
               loop     @b
                clc
                ret
BIOS_not_An:
                stc
                ret
An_patch        ENDP

CodePtn_A       label   byte    ; 02D4h--
                mov     byte ptr es:[2000h],07h ; Initialize Drive Parameters
                mov     byte ptr es:[2001h],00h 
                mov     byte ptr es:[200Ah],11h ; sector count
                mov     al,[bp+00h]
                and     al,0Fh
                shl     al,04h
                mov     es:[2004h],al
                mov     al,byte ptr ds:[0457h]
                and     al,38h
                cmp     al,20h
                jnz     OFFSET_0303
                or      byte ptr es:[2004h],03h ;
                jmp     OFFSET_0309
                nop     
OFFSET_0303:    
                or      byte ptr es:[2004h],07h; 
OFFSET_0309:
CodePtn_A_end   label   byte

PatPtn_A        label   byte
                mov     word ptr es:[2000h],0007h ; Initialize Drive Parameters
                push    bx
;;                mov     bx,offset NewFunc_HS_AX - offset NEW_CODE_1C10 
                DB      0BBh    ;mov bx,imm
ifdef   AN_ONLY
                mov     bx,offset CALL_OFFSET6  ; An 
                add     [bx],ax
                mov     bx,offset CALL_OFFSET7  ; An 
                add     [bx],ax
endif

;----------------------------------
CALL_OFFSET6    label word
                DW      offset NewFunc_HS_AX - offset NEW_CODE_1C10 
                call    bx
                pop     bx
                mov     es:[200Ah],al
                dec     ah
                mov     al,[bp+00h]
                and     al,0Fh
                shl     al,04h
                mov     es:[2004h],al
                mov     al,byte ptr ds:[0457h]
                and     al,38h
                cmp     al,20h
                jnz     OFFSET_0303_P
                or      byte ptr es:[2004h],03h ; 2004_HEAD_COUNT_M1
                jmp     OFFSET_0309_P
OFFSET_0303_P:
                or      byte ptr es:[2004h],ah
OFFSET_0309_P:
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
PatPtn_A_end    label   byte

;---------------------------------------------------

CodePtn_An       label   byte
; ----- Over 552MByte DISK -------------
OFFSET_0BE6:    
                mov     byte ptr ds:[05B0h],0FFh ; 111b|hCuȂ=over 552MB
                and     byte ptr ds:[0457h],0C7h
                mov     cx,0088h        ; DX:AX= C*H*S 
                div     cx              ; AX= cyls divided by (17*8)
                mov     es:[2082h],ax   ; BIOS cylinder count
                or      byte ptr ds:[0457h],10h ; phys sect len=512
                DB      0EBh     ; jmp return point
                DB      54h
                DB      90h
                DB      0
                DB      0
CodePtn_An_end  label   byte


PatPtn_An       label   byte
OFFSET_P_0BE6:
                mov     byte ptr ds:[05B0h],0FFh ; 111b|hCuȂ=over 552MB
                and     byte ptr ds:[0457h],0C7h
                push    bx
                DB      0BBh
CALL_OFFSET7    label   word
                DW      0000h
                call    bx
                pop     bx
                mov     es:[2082h],ax   ; BIOS cylinder count
                or      byte ptr ds:[0457h],10h ; phys sect len=512
                ret
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
                NOP     
PatPtn_An_end   label   byte

FastIDE         label   byte
                push    dx
                push    ax
                mov     dx,0432h
                mov     al,12h
                out     dx,al
                pop     ax
                pop     dx
                RETF
FastIDE_end     label   byte

