AP3_BX3_patch   PROC    near
; Func_A (NewFunc_HS_AX)        ; An error occurred in Xn
                mov     si,offset CodePtnA
                mov     cx,offset CodePtnA_end
                call    scan_pattern
                jc      BIOS_not_AP3
                mov     di,bx
                mov     si,offset PatPtnA
           rep  movsb

; Func_F84
                mov     si,offset CodePtnF84
                mov     cx,offset CodePtnF84_end
                call    scan_pattern
                jc      BIOS_not_AP3
                mov     di,bx
                mov     si,offset PatPtnF84
           rep  movsb

; Func_C
                mov     si,offset CodePtnC
                mov     cx,offset CodePtnC_end
                call    scan_pattern
                jc      BIOS_not_AP3
                mov     di,bx
                mov     si,offset PatPtnC
           rep  movsb

; Func_D (NewFunc_HS_AX)
                mov     si,offset CodePtnD
                mov     cx,offset CodePtnD_end
                call    scan_pattern
                jc      BIOS_not_AP3
                mov     di,bx
                mov     si,offset PatPtnD
           rep  movsb

; NewFunc2_HS_AX
                mov     si,offset CodePtnE
                mov     cx,offset CodePtnE_end
                call    scan_pattern
                jc      BIOS_not_AP3
                mov     di,bx
                mov     si,offset PatPtn_HS_AX
           rep  movsb

; Func_ParamSET
                mov     si,offset CodePtnParamSET
                mov     cx,offset CodePtnParamSET_end
                call    scan_pattern
                jc      BIOS_not_AP3
                mov     di,bx
                mov     si,offset PatPtnSET
           rep  movsb

; D800:1C10h(an) ,1E00h(Xs)̋󂫂 ExCode 𖄂߂
                mov     di, NEW_ENTRY           ; patch entry
                mov     cx,(offset CodeEnd - offset ExCode)
                mov     si,offset Excode
CopyExCode:      mov     al,cs:[si]
                inc     si
                stosb
               loop     CopyExCode
                clc
                ret
BIOS_not_AP3:
                stc
                ret
AP3_BX3_patch   ENDP
;===========================================================================
;XS:03BC 
CodePtnA        label   byte            ; Initialize Device Parameters
                mov     byte ptr es:[2000h],07h ; ̃R}hԍ
                mov     byte ptr es:[2001h],00h
                mov     byte ptr es:[200Ah],11h ; Œ̃ZN^17
                mov     al,[bp+00h]             ; foCXihCujԍ
                and     al,0Fh                  ; Ô߂̃}XN
                shl     al,04h                  ; DHWX^̒lɂ
                mov     es:[2004h],al           ; D800:[2004]Dev/HeadWX^
                mov     al,ds:[0457h]           ; {IDE BIOS flag 
                test    byte ptr [bp+00h],01h   ; foCXPH
                jz      OFFSET_0402drv          ;
;            ; 1st drive
                and     al,07h  ; al, 00000111b ; foCXP̃}XN
                cmp     al,04h  ; al, 00000100b ==> 20MB
                jmp     OFFSET_0406_256BS       ; foCXPł256B/SɂȂ
                nop
OFFSET_0402drv: ; 2nd drive
                and     al,38h  ; al, 00111000b ; foCXÕ}XN
                cmp     al,20h  ; al, 00100000b ==> 20MB
OFFSET_0406_256BS:                              
                jnz     OFFSET_0411_NOT_SASI    ; 256B/słƂ
                or      byte ptr es:[2004h],03h ; Dev/Head HEAD=4 Ƃ-1
                jmp     OFFSET_0417
                nop
OFFSET_0411_NOT_SASI:                           ; 512B/słƂ
                or      byte ptr es:[2004h],07h ; Dev/Head HEAD=8 Ƃ-1
OFFSET_0417:
;               jmp     xxxx                    ; R}hs
CodePtnA_end    label   byte
;- - - - - - - - - - - - - - - - - - - -
PatPtnA         label   byte
                mov     WORD PTR es:[2000h],0007h ; [hɂ܂Ƃ߂
                push    bx
;                mov     bx,offset NewFunc_HS_AX
                DB      0BBh
CALL_OFFSET1    label word
                DW      offset NewFunc_HS_AX - offset NEW_CODE_1C10 
                call    bx      ; P[^ułȂ
                pop     bx              ; V[NGA瓾
                mov     es:[200Ah],al   ; ZN^Zbg
                dec     ah              ; wbh͂P
                mov     al,[bp+00h]     ; hCuԍ
                and     al,0Fh
                shl     al,04h
                mov     es:[2004h],al   ; Dev/Head WX^
                mov     al,ds:[0457h]   ; [NGAtO
                test    byte ptr [bp+00h],01
                jz      OFFSET_0403P
;             ; PhCu
                and     al,07h          ; ̖ʓ|
                cmp     al,04h          ;
                jmp     OFFSET_0407P
OFFSET_0403P: ; QhCu
                and     al,38h          ;
                cmp     al,20h          ;
OFFSET_0407P: ; 256oCg^ZN^̂Ƃ
                jnz     OFFSET_0411P
                or      byte ptr es:[2004h],03h ; Dev/Head
                jmp     OFFSET_0416P
OFFSET_0411P: 
                or      byte ptr es:[2004h],ah
OFFSET_0416P: 
                nop
;               jmp     xxxx                    ; R}hs
PatPtnA_end    label   byte

;===========================================================================
; XS:0A7A ; 
CodePtnD        label   byte            ; CHS to LBA conversion O
                test    byte ptr [bp+00],80h    ; ? DA/UA ==80h or 00h
                jnz     OFFSET_0AA2
                mov     dh,00h                  ; LBA mode
                mov     dl,[bp+06h]             ;
                mov     ax,[bp+04h]             ;
                jmp     $+2Eh+2
OFFSET_0AA2:
                mov     cx,0021h       ; 33 (decimal)ZN^
           ;    call    ***
CodePtnD_end    label   byte
; - - - - - - - - - - - - - - - - - - - 
PatPtnD        label   byte
                test    byte ptr [bp+00],80h    ; LBAŵƂ
                jnz     OFFSET_0AA2_P
                mov     dx,[bp+06h]
                mov     ax,[bp+04h]
                RET                     ; ^[
OFFSET_0AA2_P:
                mov     cx,0021h       ; =33 (decimal)
                nop
                nop
                nop
                nop
                nop
PatPtnD_end     label   byte
;================================================================
; ifjcall EMsec256BS ; 256oCg^ZN^̏[`
;================================================================
CodePtnE        label   byte            ;  CHS to LBA conversion 㔼
                jz      OFFSET_0AAD
                mov     cx,0011h        ; 512B/ŝƂZN^17
OFFSET_0AAD:
                mov     ax,cx
                mul     byte ptr [bp+07h]       ; head
                push    ax
                mov     ax,cx
                push    es
                push    cs
                pop     es
                mul     byte ptr es:[bx+03h]    ;
                pop     es
                mul     word ptr [bp+04h]       ;
                pop     cx
CodePtnE_end   label   byte
;- - - - - - - - - - - - - - - - - - - -
PatPtn_HS_AX    label   byte
                jz      OFFSET_0AB3_P
                push    es              ; łESޔKv
                push    bx
;                mov     bx,offset NewFunc2_HS_AX
                DB      0BBh
CALL_OFFSET2    label word
                DW      offset NewFunc2_HS_AX - offset NEW_CODE_1C10 
                call    bx      ; P[^ułȂ
                pop     bx      ; Vp[^GA
                pop     es
OFFSET_0AB3_P:
                mov     ax,cx   ; ԒlƂCXH:SZbgĂ
                mul     byte ptr [bp+07h]       ; wbhԒn
                push    ax
                mov     ax,cx
                mul     DL
                mul     word ptr [bp+04h]       ; V_Ԓn
                pop     cx
                nop
                nop
                nop
                nop
PatPtn_HS_AX_end     label   byte

;===========================================================================

CodePtnC        label   byte            ; LBA to CHS conversion
                mov     cx,0011h
                push    cx
                    push    ax
                        mov     ax,cx
                        push    es
                        push    cs
                        pop     es
                        mul     byte ptr es:[bx+02h]
                        pop     es
                        mov     CX,AX   ; cx=H0*S0
                    pop     ax          ; DX:AX= LBA
                    div     cx
                    mov     es:[2002h],ax
                pop     cx

CodePtnC_end    label   byte
;- - - - - - - - - - - - - - - - - - - -
PatPtnC         label   byte
                push    bx
                push    ax
;                mov     bx,offset NewFunc_HS_AX
                DB      0BBh
CALL_OFFSET3    label word
                DW      offset NewFunc_HS_AX - offset NEW_CODE_1C10 
                call    bx              ; P[^ułȂ
                mov     bl,al           ; return  value AX=H0:S0 ,BX=0
                mov     cl,ah
                mul     cl
                mov     cx,ax           ; cx=H0*S0
                pop     ax              ; CX=(H0*S0), DX:AX= LBA
                div     cx              ; LBA / (H0*S0)
                mov     es:[2002h],ax   ; ax=cylinder number
                                        ; dx=head remn.
                mov     cx,bx           ; cx=S0
                pop     bx

                nop
                nop
                nop
PatPtnC_end     label   byte

;===========================================================================

CodePtnF84      label   byte            ; int 1Bh, ah=84h return
                jz      OFFSET_044C
                mov     word ptr [bp+02h],0200h; ZN^ 512Bytes
                mov     byte ptr [bp+06h],11h  ; 17 ZN^ ; C6460611
OFFSET_044C:    pop     ax
                mov     dl,es:[bx+02h]          ; BIOSwbh
                mov     [bp+07h],dl             ; Rs[
                mov     dx,es:[bx]              ; BIOSV_
;               call    es_D800         ; ESWX^D800/E800Zbg
CodePtnF84_end  label   byte
;- - - - - - - - - - - - - - - - - - - -
PatPtnF84       label   byte
                jz      OFFSET_0456_P   ; 256oCg/ZN^̂ƂĂȂ
                mov     word ptr [bp+02h],0200h
                push    bx
;                mov     bx,offset NewFunc_HS_AX
                DB      0BBh
CALL_OFFSET4    label word
                DW      offset NewFunc_HS_AX - offset NEW_CODE_1C10 
                call    bx              ; P[^ułȂ
                mov     [bp+06],ax
                mov     dh,0
                mov     dl,ah
                pop     bx
OFFSET_0456_P:  pop     ax
                nop
PatPtnF84_end   label   byte

;===========================================================================

CodePtnParamSET      label   byte
;       XS57:0EF3 
                nop     ; ߐ nop*13
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                mov     cx,0088h        
                div     cx
                mov     es:[bx+02h],ax  ; V_
                mov     cl,0FFh         ; 11111111
                and     ch,0C7h         ; 11000111 
                or      ch, 10h         ; 00010000
                JMP     $+2+46h         ; JMP 0F5B(Xs)
                NOP
                DB      00h,00h         ; AhX 0F16 (Xs)
CodePtnParamSET_end  label   byte
;- - - - - - - - - - - - - - - - - - - -
PatPtnSET       label   byte
                nop     ; ߐ
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop

                push    bx
;;              mov     bx,offset NEW_CODE_1C10
                DB      0BBh
CALL_OFFSET5    label word
                DW   0000h      ;   offset NEW_CODE_1C10(real)
                call    bx              ; P[^ułȂ
                pop     bx              ; V[NGAɃZbg
                mov     es:[bx+02h],ax  ; [NGAɂZbg
                mov     cl,0FFh
                and     ch,0C7h
                or      ch, 10h
                JMP     $+2+46h-2        ; JMP 0F5B(Xs)
PatPtnSET_end   label   byte
;===============================================================2019-7-21

